library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity vga_control is
     Port ( clk            : in  STD_LOGIC;
                start      : in  STD_LOGIC;
                reset        : in  STD_LOGIC;
                button_l   : IN std_logic;
                button_r   : IN std_logic;
                rgb            : out  STD_LOGIC_VECTOR (2 downto 0);
                h_s           : out  STD_LOGIC;
                v_s            : out  STD_LOGIC);
      end vga_control;

architecture Behavioral of vga_control is

COMPONENT img_gen
    PORT( clk              : IN std_logic;
                 x_control    : IN std_logic_vector(9 downto 0);
                 button_l     : IN std_logic;
                 button_r     : IN std_logic;
                 y_control     : IN std_logic_vector(9 downto 0);
                 video_on   : IN std_logic;          
                rgb              : OUT std_logic_vector(2 downto 0) );
  END COMPONENT;

COMPONENT sync_mod
PORT( clk            : IN std_logic; -- 50 MHz
              reset        : IN std_logic;
              start      : IN std_logic;          
             y_control   : OUT std_logic_vector(9 downto 0);
              x_control   : OUT std_logic_vector(9 downto 0);
              h_s           : OUT std_logic;
              v_s            : OUT std_logic;
              video_on   : OUT std_logic );
END COMPONENT;

component clk_wiz_0
port
 (-- Clock in ports
  clk_in1           : in     std_logic;
  -- Clock out ports
  clk_out1          : out    std_logic;
  -- Status and control signals
  reset             : in     std_logic
 );
end component;

signal x,y:std_logic_vector(9 downto 0);
signal video:std_logic;
signal clk_50 :std_logic;

begin
 U1: img_gen PORT MAP(clk => clk_50 ,  x_control => x, button_l => button_l  ,button_r => button_r, y_control => y, video_on => video, rgb => rgb);

 U2: sync_mod PORT MAP(clk => clk_50, reset => reset, start => start, y_control => y, x_control => x , h_s => h_s ,v_s => v_s, video_on => video);
 
 U3: clk_wiz_0 PORT MAP(clk_in1 => clk, clk_out1 => clk_50, reset => reset);
                                                                                                                                                          
end Behavioral;
